Package: Lahman
Type: Package
Title: Sean 'Lahman' Baseball Database
Version: 14.0-0
Date: 2026-02-11
Authors@R: c(person(given = "Michael", family = "Friendly", role="aut", email="friendly@yorku.ca"), 
        person(given ="Chris", family = "Dalzell", role=c("cre","aut"), email="cdalzell@gmail.com"),
        person(given ="Martin", family = "Monkman", role="aut"),
        person(given= "Dennis", family = "Murphy", role="aut"), 
        person(given ="Vanessa", family = "Foot", role="ctb"),
        person(given = "Justeena", family = "Zaki-Azat", role="ctb"),
        person(given = "Daniel J", family = "Eck", role="ctb", email="dje13@illinois.edu"),
        person(given = "Sean", family = "Lahman", role="cph")
        )
Author: Michael Friendly [aut],
  Chris Dalzell [cre, aut],
  Martin Monkman [aut],
  Dennis Murphy [aut],
  Vanessa Foot [ctb],
  Justeena Zaki-Azat [ctb],
  Daniel J Eck [ctb],
  Sean Lahman [cph]
Maintainer: Chris Dalzell <cdalzell@gmail.com>
Description: Provides the tables from the 'Sean Lahman Baseball Database' as
    a set of R data.frames. It uses the data on pitching, hitting and fielding
    performance and other tables from 1871 through 2024, as recorded in the 2025
    version of the database. Documentation examples show how many baseball
    questions can be investigated.
Language: en-US
Depends: R (>= 3.5.0)
Suggests: lattice, ggplot2, googleVis, data.table, vcd, reshape2,
        tidyr, knitr, rmarkdown, car, plyr, tidyverse
Imports: dplyr
Encoding: UTF-8
License: GPL
URL: https://cdalzell.github.io/Lahman/,
        https://CRAN.R-project.org/package=Lahman
LazyLoad: yes
LazyData: yes
LazyDataCompression: xz
BugReports: https://github.com/cdalzell/Lahman/issues
Repository: CRAN
NeedsCompilation: no
RoxygenNote: 7.3.3
VignetteBuilder: knitr
Packaged: 2026-02-12 00:01:36 UTC; DZ
Date/Publication: 2026-02-12 06:10:25 UTC
Built: R 4.6.0; ; 2026-04-26 12:35:08 UTC; unix

# Script to read the Lahman data base .csv files & create Rdata files
library("archive")
source("D:/Dev/Projects/Lahman/inst/scripts/dataMapping.R")

# directory where the .csv files will be created
indir <- "D:/Dev/Projects/Lahman/source-data"

# directory where the .RData files will be created
outdir <- "D:/Dev/Projects/Lahman/data"

setwd(indir)

# local data location
dataFile <- "lahman_1871-2025_csv.zip"

# TODO: find permanent url to download source zip file (if possible)
# - Data can be found at: https://sabr.app.box.com/s/rsry2en86bimvybwsorumfsxmf91002a?page=1
if (!file.exists(dataFile)) {
  print("Current download URL unknown")
  #zipfile <- "https://www.dropbox.com/scl/fi/hy0sxw6gaai7ghemrshi8/lahman_1871-2023_csv.7z?rlkey=edw1u63zzxg48gvpcmr3qpnhz&dl=1"
  #download.file(zipfile, dataFile)
}

archive_extract(dataFile, dir=indir)

# Read the Lahman MLB .csv files and create .RData and .Rd files
indir <- paste0(indir, "/lahman_1871-2025_csv")
setwd(indir)

files <- list.files(indir, pattern="csv", full.names=TRUE)

for (i in 1:length(files)) {
	inp <- read.csv(file=files[i], header=TRUE, stringsAsFactors=FALSE, na.strings="", encoding="UTF-8")
	cat("Read:", files[i], "\trows: ", nrow(inp), " cols: ", ncol(inp), "\n")

	# make a few variables factors
	if("lgID" %in% names(inp)) inp$lgID <- factor(inp$lgID)
	if("teamID" %in% names(inp)) inp$teamID <- factor(inp$teamID)
	if("inducted" %in% names(inp)) inp$inducted <- factor(inp$inducted)
	if("category" %in% names(inp)) inp$category <- factor(inp$category)
	if("plyrMgr" %in% names(inp)) inp$plyrMgr <- factor(inp$plyrMgr)
	if("franchID" %in% names(inp)) inp$franchID <- factor(inp$franchID)
	if("lgIDwinner" %in% names(inp)) inp$lgIDwinner <- factor(inp$lgIDwinner)
	if("lgIDloser" %in% names(inp)) inp$lgIDloser <- factor(inp$lgIDloser)
	if("teamIDwinner" %in% names(inp)) inp$teamIDwinner <- factor(inp$teamIDwinner)
	if("teamIDloser" %in% names(inp)) inp$teamIDloser <- factor(inp$teamIDloser)

	name <- sub(".csv", "", basename(files[i]))
	assign(name, inp)
}

# HallOfFame uses both empty strings and "NA"
HallOfFame[HallOfFame == 'NA'] <- NA
hofNumCols <- c("ballots", "needed", "votes")
HallOfFame[hofNumCols] <- sapply(HallOfFame[hofNumCols], as.numeric)

# Date variables

# $ debut       : chr  "4/13/1954 0:00:00" "4/10/1962 0:00:00" "7/26/1977 0:00:00" "9/10/2001 0:00:00" ...
# $ finalGame   : chr  "10/3/1976 0:00:00" "9/26/1971 0:00:00" "10/3/1990 0:00:00" "4/13/2006 0:00:00" ...
 
##################
# Convert debut/finalGame from character to Date class
# The format in the as.Date() function is the 'informat', 
# in SASspeak; the output format is a calendar date in 
# yyyy-mm-dd format.
People <- within(People, {
#    debut = as.Date(debut, 
#                    format = '%m/%d/%Y %H:%M:%s',
#                    origin = '1970-01-01')
#    finalGame = as.Date(finalGame, 
#                        format = '%m/%d/%Y %H:%M:%s',
#                        origin = '1970-01-01')
   birthDate = as.Date(paste(birthYear, birthMonth, birthDay, sep = '-'),
                       format = '%Y-%m-%d')
   deathDate = as.Date(paste(deathYear, deathMonth, deathDay, sep = '-'),
                       format = '%Y-%m-%d')
   bats = factor(bats)
   throws = factor(throws)
})

# do some data remapping due to minor schema drift
HallOfFame <- mapHallOfFame(HallOfFame)
HomeGames <- mapHomeGames(HomeGames)
Parks <- mapParks(Parks)
People <- mapPeople(People)

setwd(outdir)

# compress mightily on save
#options(save.defaults=list(compress="xz", compression_level=9))

save(AllstarFull,         file="AllstarFull.RData", version = 3)        
save(Appearances,         file="Appearances.RData", version = 3)        
save(AwardsManagers,      file="AwardsManagers.RData", version = 3)     
save(AwardsPlayers,       file="AwardsPlayers.RData", version = 3)      
save(AwardsShareManagers, file="AwardsShareManagers.RData", version = 3)
save(AwardsSharePlayers,  file="AwardsSharePlayers.RData", version = 3) 
save(Batting,             file="Batting.RData", version = 3)
save(BattingPost,         file="BattingPost.RData", version = 3)
save(CollegePlaying,      file="CollegePlaying.RData", version = 3)
save(Fielding,            file="Fielding.RData", version = 3)
save(FieldingOF,          file="FieldingOF.RData", version = 3)
save(FieldingOFsplit,     file="FieldingOFsplit.RData", version = 3)
save(FieldingPost,        file="FieldingPost.RData", version = 3)
save(HallOfFame,          file="HallOfFame.RData", version = 3)
save(HomeGames,           file="HomeGames.RData", version = 3)
save(Managers,            file="Managers.RData", version = 3)
save(ManagersHalf,        file="ManagersHalf.RData", version = 3)
save(Parks,               file="Parks.RData", version = 3)
save(People,              file="People.RData", version = 3)
save(Pitching,            file="Pitching.RData", version = 3)
save(PitchingPost,        file="PitchingPost.RData", version = 3)
save(Salaries,            file="Salaries.RData", version = 3)
save(Schools,             file="Schools.RData", version = 3)
save(SeriesPost,          file="SeriesPost.RData", version = 3)
save(Teams,               file="Teams.RData", version = 3)
save(TeamsFranchises,     file="TeamsFranchises.RData", version = 3)
save(TeamsHalf,           file="TeamsHalf.RData", version = 3)

# version currently still defaults to 2 here
tools::resaveRdaFiles(outdir, compress="xz", compression_level=9, version = 3)

# only ran this once, since all .Rd files were extensively edited
# TODO: come up with a better way to automatically update Rd files with count/year/etc updates
if (FALSE) {
  promptData(Allstar,             filename="Allstar.Rd")            
  promptData(AllstarFull,         filename="AllstarFull.Rd")        
  promptData(Appearances,         filename="Appearances.Rd")        
  promptData(AwardsManagers,      filename="AwardsManagers.Rd")     
  promptData(AwardsPlayers,       filename="AwardsPlayers.Rd")      
  promptData(AwardsShareManagers, filename="AwardsShareManagers.Rd")
  promptData(AwardsSharePlayers,  filename="AwardsSharePlayers.Rd") 
  promptData(Batting,             filename="Batting.Rd")            
  promptData(BattingPost,         filename="BattingPost.Rd")
  promptData(CollegePlaying,      filename="CollegePlaying.Rd") 
  promptData(Fielding,            filename="Fielding.Rd")           
  promptData(FieldingOF,          filename="FieldingOF.Rd")         
  promptData(FieldingPost,        filename="FieldingPost.Rd")       
  promptData(HallOfFame,          filename="HallOfFame.Rd")         
  promptData(HOFold,              filename="HOFold.Rd")             
  promptData(Managers,            filename="Managers.Rd")           
  promptData(ManagersHalf,        filename="ManagersHalf.Rd")
  promptData(Pitching,            filename="Pitching.Rd")           
  promptData(PitchingPost,        filename="PitchingPost.Rd")       
  promptData(Salaries,            filename="Salaries.Rd")           
  promptData(Schools,             filename="Schools.Rd")
  promptData(SeriesPost,          filename="SeriesPost.Rd")         
  promptData(Teams,               filename="Teams.Rd")              
  promptData(TeamsFranchises,     filename="TeamsFranchises.Rd")    
  promptData(TeamsHalf,           filename="TeamsHalf.Rd")          
  promptData(Xref_Stats,          filename="Xref_Stats.Rd")         
}

## ----Setup, message=FALSE-----------------------------------------------------

# package load 
library(Lahman)
library(ggplot2)
library(dplyr)


## ----message=FALSE------------------------------------------------------------


data(Teams)


MLB_RPG <- Teams %>%
  filter(yearID > 1900, lgID != "FL") %>%
  group_by(yearID) %>%
  summarise(R=sum(R), RA=sum(RA), G=sum(G)) %>%
  mutate(leagueRPG=R/G, leagueRAPG=RA/G)


## ----message=FALSE------------------------------------------------------------

MLBRPGplot <- ggplot(MLB_RPG, aes(x=yearID, y=leagueRPG)) +
  geom_point() +
  geom_smooth(span = 0.25) +
  scale_x_continuous(breaks = seq(1900, 2015, by = 20)) +
  scale_y_continuous(limits = c(3, 6), breaks = seq(3, 6, by = 1))

MLBRPGplot


## ----message=FALSE------------------------------------------------------------
  
MLBRPGplot +
  ggtitle("MLB run scoring, 1901-2016") +
  theme(plot.title = element_text(hjust=0, size=16)) +
  xlab("year") +
  ylab("team runs per game")


## ----message=FALSE------------------------------------------------------------

MLBRPGplot +
  labs(title = "MLB run scoring, 1901-2016",
       subtitle = "Run scoring in 2016 was the highest in seven years",
       caption = "Source: the Lahman baseball database", 
       x = "year", y = "team runs per game") 

## ----nomessages, echo = FALSE-------------------------------------------------
# set some default options for chunks
knitr::opts_chunk$set(
  warning = FALSE,   # avoid warnings and messages in the output
  message = FALSE,
  collapse = TRUE,   # collapse all output into a single block
  tidy = FALSE,      # don't tidy our code-- assume we do it ourselves
  fig.height = 5,
  fig.width = 5
)
options(digits=4)    # number of digits to display in output; can override with chunk option R.options=list(digits=)
par(mar=c(3,3,1,1)+.1)

set.seed(1234)       # reproducibility

## ----load-packages------------------------------------------------------------
library(Lahman) 
library(ggplot2) 
library(dplyr)
library(car)

## ----Batting-names------------------------------------------------------------
data("Batting", package="Lahman") # load the data
str(Batting) # take a look at the structure of the complete data set, as it is

## ----Batting-filter-----------------------------------------------------------
Batting <- Batting %>%
  select(yearID, AB, SO, HR) %>% # select the variables that we need
  group_by(yearID) %>% # group by year, so that each row is one year
  summarise(across(everything(), sum)) # we want the sum of AB, HR, and SO in the other rows

FullBatting<- Batting %>% # create a new variable that has SO rate and HR rate
  filter(yearID >= 1950) %>% # select the years from 1900+
  mutate(SO_rate = (SO/AB)*100, HR_rate = (HR/AB)*100) #add SO rate and HR rate as percentages to our data frame  
  
some(FullBatting) # look at a set of random observations

## -----------------------------------------------------------------------------
dim(FullBatting) # show the dimensions of the data frame

## -----------------------------------------------------------------------------
sum(FullBatting$SO) # find the sum of strikeout column

## -----------------------------------------------------------------------------
mean(FullBatting$SO_rate) # find the mean of the strikeout rate column

## -----------------------------------------------------------------------------
sum(FullBatting$HR) # find the sum of home run column

## -----------------------------------------------------------------------------
mean(FullBatting$HR_rate) # find the mean of the home run rate column

## -----------------------------------------------------------------------------
corr <- cor.test(FullBatting$SO_rate, FullBatting$HR_rate)
corr # find the correlation between strikeout rate and home run rate

## -----------------------------------------------------------------------------
Model_Totals <- lm(SO_rate~HR_rate, data=FullBatting)
summary(Model_Totals) # look at the model totals

## -----------------------------------------------------------------------------
plot <- ggplot(FullBatting, aes(x= SO_rate, y= HR_rate))+
geom_point()+ 
  xlab("Strikeout Rate") +
  ylab("Home Run Rate") +
  ggtitle("Relationship Between Strikeouts and Home Runs")
plot + stat_smooth(method= "lm") ##stat_smooth fits the model and then we plot the linear regression model

## ----nomessages, echo = FALSE-------------------------------------------------
# set some default options for chunks
knitr::opts_chunk$set(
  warning = FALSE,   # avoid warnings and messages in the output
  message = FALSE,
  collapse = TRUE,   # collapse all output into a single block
  tidy = FALSE,      # don't tidy our code-- assume we do it ourselves
  fig.height = 5,
  fig.width = 7
)
options(digits=4)    # number of digits to display in output; can override with chunk option R.options=list(digits=)

set.seed(1234)       # reproducibility

## ----load-data----------------------------------------------------------------
library("dplyr")
data(Batting, package="Lahman")
str(Batting) #take a look at the data

## ----select-mutate------------------------------------------------------------
batting <- Batting %>% 
  # select the variables that we want left after we filter the data
  select(yearID, H, X2B, X3B, HR) %>%
  # select the years from 1871+
  filter(yearID >= 1871) %>% 
  group_by(yearID) %>%
  summarise_all(funs(sum(., na.rm=TRUE))) %>% 
  # we summarize by year, and then na.rm takes care of 0's in the data
  mutate(X1 = H-(X2B+X3B+HR)) %>% #create a column for singles
  # we eventually want these as a percentage of hits, so we can do the math now 
  mutate(Single = X1/H*100) %>% 
  mutate(Double = X2B/H*100) %>% 
  mutate(Triple = X3B/H*100) %>% 
  mutate(HomeRun = HR/H*100)

## ----select2------------------------------------------------------------------
bat <- batting %>% 
  select(yearID, Single, Double, Triple, HomeRun)
#this makes a nice looking data frame before we move on

## -----------------------------------------------------------------------------
library(reshape2)
bat_long <- melt(bat, id.vars = c("yearID"))
head(bat_long)

## ----plot1--------------------------------------------------------------------
library(ggplot2)
hitsperyear <- ggplot(bat_long, aes(x=yearID, y= value, col=variable)) +
       geom_line() + 
  xlab("Major League Baseball Season") + 
  ylab("Percentage") + 
  ggtitle("Hits by Type in Major League Baseball") + 
  scale_x_continuous(breaks = c(1870, 1885, 1900, 1915, 1930, 1945, 
                                1960, 1975, 1990, 2005, 2020 )) + 
  scale_y_continuous(breaks = c(0, 25, 50, 75, 100))+
  guides(colour=guide_legend(reverse=TRUE, 
                             aes(ggtitle= "Type of Hit")))
hitsperyear

## ----plot2--------------------------------------------------------------------
hitsperyear + geom_smooth(method="lm")

# check reverse dependencies

library(devtools)
rev_pkgs <- revdep("Lahman")

# > rev_pkgs
# [1] "baseballDBR"   "broom"         "dados"         "datos"         "dbplyr"        "dplyr"         "ibawds"        "implyr"       
# [9] "mdsr"          "pinnacle.data" "raw"           "sparklyr"      "teamcolors"  

# devtools::revdep_check() - deprecated

# see: https://github.com/r-lib/revdepcheck

#source("https://install-github.me/r-lib/revdepcheck")
revdepcheck::revdep_check()

# or maybe
usethis::use_revdep()

# added to help maintain column naming consistency
library(dplyr)

mapHallOfFame <- function(df) {
  df <- df %>% rename(yearID = yearid)
  
  return(df)
}

mapHomeGames <- function(df) {
  colnames(df) <- gsub("(.*)key$", "\\1.key", colnames(df))
  colnames(df) <- gsub("^span(.*)", "span.\\1", colnames(df))
  
  return(df)
}

mapParks <- function(df) {
  colnames(df) <- gsub("^park(.*)", "park.\\1", colnames(df))
  df <- df %>% select(-ID)
  
  return(df)
}

mapPeople <- function(df) {
  df <- df %>% select(-ID)
  
  return(df)
}

# Compare data sets from Lahman package to new ones created from .csv files


datalist <- scan(system.file("data", "datalist", package="Lahman"), what="character")

#datalist <- scan(what="character")
#AllstarFull
#Appearances
#AwardsManagers
#AwardsPlayers
#AwardsShareManagers
#AwardsSharePlayers
#Batting
#BattingPost
#Fielding
#FieldingOF
#FieldingPost
#HallOfFame
#Managers
#ManagersHalf
#People
#Pitching
#PitchingPost
#Salaries
#Schools
#SchoolsPlayers
#SeriesPost
#Teams
#TeamsFranchises
#TeamsHalf

# read in lahman2012 data files and change names from XXX to XXX2012
# so they can be compared with the existing ones.

dir <- "C:/R/data/lahman2012/RData/"
for (i in 1:length(datalist)) {
	load(paste0(dir, datalist[i], ".RData")) 
	assign(paste0(datalist[i], "2012"), get(datalist[i]))
	}

rm(list=datalist)

# match two data frames based on ID variables
XnotinY <- function(X,Y){
	IDvars <- unlist(lapply(X, function(x) grep('.*ID$', colnames(X), value=TRUE)))
	X <- X[,IDvars]
	Y <- Y[,IDvars]
   X.vec <- apply(X, 1, paste, collapse = "")
   Y.vec <- apply(Y[,IDvars], 1, paste, collapse = "")
   X.without.Y.rows <- X[!X.vec %in% Y.vec,]
   return(nrow(X.without.Y.rows))
 }

# compare two versions of a data frame	
compare <- function(df1, df2) {
	name1 <- df1
	name2 <- df2
	df1 <- get(df1)
	df2 <- get(df2)
	vars1 <- colnames(df1)
	vars2 <- colnames(df2)
	cat(paste("\nComparing ", name1, "<->", name2, "\n"))
	if (setequal(vars1, vars2)) {
		cat(paste("   ", length(vars1), "variable names are in both:\n     ",
		          paste(vars1, collapse=', '),"\n"))
		ord <- all(vars1==vars2)
		cat(paste("    variable names in", ifelse(ord, "same", "different"), "order\n"))
		}
	else {
		cat(paste("   variable names in", name1, "but not in", name2, ":", paste(setdiff(vars1, vars2), collapse=", "), "\n"))
		cat(paste("   variable names in", name2, "but not in", name1, ":", paste(setdiff(vars2, vars1), collapse=", "), "\n"))
		}
	obs1 <- nrow(df1); obs2 <- nrow(df2)
	cat(paste("   ", obs1, "cases in", name1, "\n   ", obs2, "cases in", name2,
	          " (diff=", obs2-obs1, ")\n"))
	if (setequal(vars1, vars2)) {
		cat("    --", paste(XnotinY(df2, df1), "cases in", name2, "but not in", name1, "\n"))
		cat("    --", paste(XnotinY(df1, df2), "cases in", name1, "but not in", name2, "\n"))
	}	
}

# load existing versions
library(Lahman)
data(list=datalist)

#
# compare old to new ones
for (i in 1:length(datalist)) {
	compare(datalist[i], paste0(datalist[i], "2012"))
}

############################################
## batting-summstats   Calculate summary statistics for the Batting data frame

## Add some useful statistics:

require('reshape2')
#require('data.table')
#require('ggplot2')
#require('lattice')

# mutate() is a faster version of transform()
# from the plyr package that allows one to use
# newly created variables in subsequent variable
# definitions within the same call.
#
# The function summstats() adds the following
# statistics for each line of a player's career
# as a hitter:
#   * batting average (BA)
#   * plate appearances (PA)
#   * total bases (TB)
#   * slugging percentage (SlugPct)
#   * on-base percentage (OBP)
#   * on-base percentage + slugging (OPS)
#   * batting average on balls in play (BABIP)
#
summstats <- function(d) {
    require('plyr')
    NAmassage <- function(x) {
    # Takes a column vector and replaces NAs by zeros
        x[is.na(x)] <- 0
        x
      }
    vars <- c('AB', 'R', 'H', 'X2B', 'X3B',
              'HR', 'RBI', 'SB', 'CS', 'BB', 'SO', 'IBB', 'HBP',
              'SH', 'SF', 'GIDP')
    d2 <- apply(d[, vars], 2, NAmassage)
    d2 <- if(is.vector(d2)) {as.data.frame(as.list(d2)) } else {
                as.data.frame(d2) }
    d2 <- mutate(d2,
      BA = ifelse(AB > 0, round(H/AB, 3), NA),
      PA = AB + BB + HBP + SH + SF,
      TB = H + X2B + 2 * X3B + 3 * HR,
      SlugPct = ifelse(AB > 0, round(TB/AB, 3), NA),
      OBP = ifelse(PA > 0,
           round((H + BB + HBP)/(PA - SH - SF), 3), NA),
      OPS = round(OBP + SlugPct, 3),
      BABIP = ifelse(AB > 0, round(H/(AB - SO), 3), NA)
      )
    data.frame(d, d2[, 18:22])
}

# This function creates a one-line summary of a player's
# cumulative career statistics, including those generated
# in the previous function. The career percentages are
# actually a weighted average of the seasonal percentages.

careerTotals <- function(d) {
    require('plyr')
    sumstats <-
      as.data.frame(as.list(colSums(as.matrix(d[, 6:24, drop = FALSE]),
                                               na.rm = TRUE)))
    cstats <- with(d, data.frame(
            beginYear = min(yearID),
            endYear = max(yearID),
            nyears = sum(stint == 1L),
            nteams = length(unique(teamID))  ))
    extrastats <- mutate(sumstats,
           BA = ifelse(AB > 0, round(H/AB, 3), NA),                   # batting average
           PA = AB + BB + HBP + SH + SF,                              # plate appearances
           TB = H + X2B + 2 * X3B + 3 * HR,                           # total bases
           SlugPct = ifelse(AB > 0, round(TB/AB, 3), NA),             # slugging percentage
           OBP = ifelse(PA > 0,                                       # on-base percentage
                       round((H + BB + HBP)/(PA - SH - SF), 3), NA),
           OPS = round(OBP + SlugPct, 3),
           BABIP = ifelse(AB > 0, round(H/(AB - SO), 3), NA)  )
    cbind(cstats, extrastats)
}

# Each of these takes about a minute or two...
# Create a *list* for the season profiles of each player
playerBattingProfiles <- dlply(Batting, .(playerID), summstats)

# Summarize into career summaries
# the output object is a *data frame*
careerBattingProfiles <- ldply(playerBattingProfiles, careerTotals)

# Individual player season records
# The difference in calls has to do with the types of objects
# from which one is extracting information
playerBattingProfiles[['iorgga01']]   # Garth Iorg
subset(careerBattingProfiles, playerID == 'brettge01') # George Brett

#########################################################################

## ----nomessages, echo = FALSE-------------------------------------------------
# set some default options for chunks
knitr::opts_chunk$set(
  warning = FALSE,   # avoid warnings and messages in the output
  message = FALSE,
  collapse = TRUE,   # collapse all output into a single block
  tidy = FALSE,      # don't tidy our code-- assume we do it ourselves
  fig.height = 5,
  fig.width = 7
)
options(digits=4)    # number of digits to display in output; can override with chunk option R.options=list(digits=)

set.seed(1234)       # reproducibility

## -----------------------------------------------------------------------------
B = 1e3
u = pnorm(rnorm(B))

## -----------------------------------------------------------------------------
u_true = 1:B / (B+1) # almost true uniform quantiles (slight bias in tails)
plot(u_true, sort(u), pch = 19, cex = 0.25, 
     main = "Uniform Q-Q Plot",
     xlab = "Theoretical Quantiles", 
     ylab = "Observed Quantiles")
lines(u_true, u_true, lty = 2, col = "red")

## -----------------------------------------------------------------------------
n = 100
u_obs = sort(unlist(replicate(B, pnorm(max(rnorm(n)))^100)))
plot(u_true, u_obs, pch = 19, cex = 0.25, 
     main = "Uniform Q-Q Plot for Maximum of 100 Normals",
     xlab = "Theoretical Quantiles", 
     ylab = "Observed Quantiles")
lines(u_true,u_true, lty = 2, col = "red")

## ----message = FALSE, warning = FALSE-----------------------------------------
# software
library(Lahman)
library(tidyverse)
#install.packages("devtools")
#library(devtools)
#devtools::install_github(repo = "DEck13/fullhouse")
#library(fullhouse)

# version numbers
packageVersion("Lahman")
packageVersion("tidyverse")
#packageVersion("fullhouse")

# data preprocessing
foo = Batting %>% 
  # get years 1911 and 1997
  filter(yearID %in% c(1911, 1997)) %>% 
  # compute batting average
  mutate(BA = round(H/AB, 3)) %>% 
  # get player names
  left_join(People %>% mutate(name = paste(nameFirst, nameLast, sep = " "))) %>% 
  # subset columns
  select(name, yearID, AB, BA) %>% 
  # only consider full-time players
  filter(AB >= 320)

## -----------------------------------------------------------------------------
max_BA = foo %>% 
  summarise(name = name[which(BA == max(BA))], max_BA = max(BA), .by = yearID)
max_BA

## -----------------------------------------------------------------------------
means_sds = foo %>% 
  summarise(mean_BA = mean(BA), sd_BA = sd(BA), .by = yearID)
means_sds

## -----------------------------------------------------------------------------
foo %>% 
  ggplot() + 
  aes(x = BA, color = factor(yearID)) + 
  geom_density() + 
  theme_minimal() + 
  labs(color = "yearID")

## -----------------------------------------------------------------------------
foo %>% 
  summarise(name = name[which(scale(BA) == max(scale(BA)))], 
            Z_max = max(scale(BA)), 
            .by = yearID)

## ----message = FALSE----------------------------------------------------------
# talent pool size (from fullhouse package)
N_1911 = 1694866
N_1997 = 9669798

# number of full-time players
ns = foo %>% summarise(n = n(), .by = yearID)
n_1911 = ns %>% filter(yearID == 1911) %>% pull(n)
n_1997 = ns %>% filter(yearID == 1997) %>% pull(n)

## -----------------------------------------------------------------------------
# means and standard deviations for BA from 1911 
means_sds_1911 = means_sds %>% 
  filter(yearID == 1911) %>% select(mean_BA, sd_BA)
# means and standard deviations for BA from 1997
means_sds_1997 = means_sds %>% 
  filter(yearID == 1997) %>% select(mean_BA, sd_BA)

## -----------------------------------------------------------------------------
# max BA from 1911 
max_BA_1911 = max_BA %>% 
  filter(yearID == 1911) %>% pull(max_BA)
# max BA from 1997 
max_BA_1997 = max_BA %>% 
  filter(yearID == 1997) %>% pull(max_BA)
# 1911 Ty Cobb's extreme batting average percentile
F_max_1911 = 
  pnorm(max_BA_1911, 
        mean = means_sds_1911$mean_BA, 
        sd = means_sds_1911$sd_BA)^n_1911
F_max_1911
# 1997 Tony Gwynn's extreme batting average percentile
F_max_1997 = 
  pnorm(max_BA_1997, 
        mean = means_sds_1997$mean_BA, 
        sd = means_sds_1997$sd_BA)^n_1997
F_max_1997

## -----------------------------------------------------------------------------
# aptitude for 1911 Ty Cobb
qnorm(F_max_1911^(1/N_1911))
# aptitude for 1997 Tony Gwynn
qnorm(F_max_1997^(1/N_1997))

## -----------------------------------------------------------------------------
# input for 1997 Tony Gwynn
sprintf("%.10f", F_max_1997^(1/N_1997))
# input for 1911 Ty Cobb
sprintf("%.10f", F_max_1911^(1/N_1911))

# construct the LahmanData data frame from the package

ldata <- vcdExtra::datasets("Lahman")
ldata <- ldata[-which(ldata$Item=="LahmanData"),]
ldata <- ldata[-grep("Labels", ldata$Item),]
ldata

# get table dimensions
dims <- t(matrix(as.numeric(unlist(strsplit(ldata$dim, "x"))), 2, nrow(ldata)))
title <- sub(" -.*", "", ldata$Title)
ldata <- data.frame(file=ldata$Item, class=ldata$class, nobs=dims[,1], nvar=dims[,2], title=title, stringsAsFactors = FALSE )

LahmanData <- ldata


save(LahmanData, file="data/LahmanData.RData")

# some examples using dplyr with Lahman

library(Lahman)
library(dplyr)

#' ## Basic manipulations

# select some variables
batting <- select(tbl_df(Batting), playerID, yearID, teamID, G, AB:H, HR) 
# sort by player, year, team
batting <- arrange(batting, playerID, yearID, teamID)
# keep only recent years
batting <- filter(batting, yearID > 1985)

# add salary to Batting data; need to match by player, year and team
# NB:  dplyr coerces yearID to character because it is a factor in Salaries
(batting <- batting %>% left_join(Salaries))

# the same in base R using merge():
batting2 <- merge(batting, 
                 Salaries[,c("playerID", "yearID", "teamID", "salary")], 
                 by=c("playerID", "yearID", "teamID"), all.x=TRUE)


# Add name, age and bat hand information from People
people <- select(tbl_df(People), playerID, birthYear, birthMonth, 
                                 nameLast, nameFirst, bats)
batting <- batting %>%
	left_join(people) %>%
	mutate(age = yearID - birthYear - ifelse(birthMonth < 10, 0, 1)) %>%
	select(-(birthYear:birthMonth))

# same with base R	                                 
People[, c('playerID', 'birthYear', 'birthMonth', 'nameLast', 'nameFirst', 'bats')]
batting2 <- merge(batting, people, all.x = TRUE)
batting2$age <- with(batting2, yearID - birthYear -
                             ifelse(birthMonth < 10, 0, 1))

#' ## Queries about players

# form a players data.frame, that is grouped by playerID
players <- group_by(batting, playerID)

# For each player, find the two years with most hits
filter(players, min_rank(desc(H)) <= 2 & H > 0)

# Within each player, rank each year by the number of games played
mutate(players, G_rank = min_rank(G))

# For each player, find every year that was better than the previous year
filter(players, G > lag(G))
# For each player, compute avg change in games played per year
mutate(players, G_change = (G - lag(G)) / (yearID - lag(yearID)))

# For each player, find all where they played more games than average
filter(players, G > mean(G))
# For each, player compute a z score based on number of games played
mutate(players, G_z = (G - mean(G)) / sd(G))

---
title: "Relationship Between Strikeouts and Home Runs"
author: "Vanessa Foot and Justeena Zaki-Azat"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Relationship Between Strikeouts and Home Runs}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r nomessages, echo = FALSE}
# set some default options for chunks
knitr::opts_chunk$set(
  warning = FALSE,   # avoid warnings and messages in the output
  message = FALSE,
  collapse = TRUE,   # collapse all output into a single block
  tidy = FALSE,      # don't tidy our code-- assume we do it ourselves
  fig.height = 5,
  fig.width = 5
)
options(digits=4)    # number of digits to display in output; can override with chunk option R.options=list(digits=)
par(mar=c(3,3,1,1)+.1)

set.seed(1234)       # reproducibility
```

```{r load-packages}
library(Lahman) 
library(ggplot2) 
library(dplyr)
library(car)
```

This vignette looks at the relationship between rate of strikeouts and home runs from the year 1950+. This question was inspired by Marchi and Albert (2016), "Analyzing Baseball Data in R." 

There are many factors that must come together for a player to launch a home run. One of those factors is swing speed—against a 94-mph fastball, every 1-mph increase in swing speed extends distance about 8 feet (Coburn, 2009). If a batter hits ~50 home runs in a season, is it safe to assume that he’s swinging for the fences, and also more likely to strike out? Babe Ruth broke the record of most home runs in a season (60) and also struck out more than any other player (89). However, in 1971, Willie Stargell hit 48 home runs and struck out 154 times, while Henry Aaron hit 47 home runs and struck out 58 times, demonstrating that home runs and strikeouts do not always go hand in hand. 

## The data files

Start with loading the files we will use here.  We do some pre-processing to make them more convenient for the analyses done later.

### The `Batting` data

The `Batting` table contains batting data at the team level going back to 1871, with a separate observation from each year. This file is available using the newest v. `r packageVersion("Lahman")`, of the `Lahman` package.  We use this to get everything we need for our analysis: at bats (AB) strikeouts (SO), and home runs (HR) for all teams since the year 1950+. 

```{r Batting-names}
data("Batting", package="Lahman") # load the data
str(Batting) # take a look at the structure of the complete data set, as it is
```

We are only using part of the table, so we will filter the data set to include only the variables that we need. 

We'll also create a new data frame that includes data from the year 1950+. The Batting table also has multiple listings for each year, so we'll collapse them using the summarize function. 

Last, we will mutate the variables so that home runs and strikeouts are divided by at bat, to add new columns "SO rate" and "HR rate." This full data frame will be called FullBatting.

```{r Batting-filter}
Batting <- Batting %>%
  select(yearID, AB, SO, HR) %>% # select the variables that we need
  group_by(yearID) %>% # group by year, so that each row is one year
  summarise(across(everything(), sum)) # we want the sum of AB, HR, and SO in the other rows

FullBatting<- Batting %>% # create a new variable that has SO rate and HR rate
  filter(yearID >= 1950) %>% # select the years from 1900+
  mutate(SO_rate = (SO/AB)*100, HR_rate = (HR/AB)*100) #add SO rate and HR rate as percentages to our data frame  
  
some(FullBatting) # look at a set of random observations
```

```{r}
dim(FullBatting) # show the dimensions of the data frame
```

##A first look at 'Batting' 

What is the total number of strikeouts in our data set?
```{r}
sum(FullBatting$SO) # find the sum of strikeout column
```
What is the average rate of strikeouts per at bat?
```{r}
mean(FullBatting$SO_rate) # find the mean of the strikeout rate column
```

How many homeruns do we have in our data set?
```{r}
sum(FullBatting$HR) # find the sum of home run column
```
What is the average rate of home runs per at bat?
```{r}
mean(FullBatting$HR_rate) # find the mean of the home run rate column
```

Is there a relationship between strikeout rate and home run rate? According to our test, there is a significant correlation. The p-value is equal to .001, with df= 65. There is a .61 correlation between strikeout rate and home run rate. 

```{r}
corr <- cor.test(FullBatting$SO_rate, FullBatting$HR_rate)
corr # find the correlation between strikeout rate and home run rate
```

We can look at the totals for interpretation purposes. We see here that for every 6.14 strikeouts, home runs increase by 4.14. 
```{r}
Model_Totals <- lm(SO_rate~HR_rate, data=FullBatting)
summary(Model_Totals) # look at the model totals
```

Create a scatterplot in ggplot, using SO rate and HR rate. 
```{r}
plot <- ggplot(FullBatting, aes(x= SO_rate, y= HR_rate))+
geom_point()+ 
  xlab("Strikeout Rate") +
  ylab("Home Run Rate") +
  ggtitle("Relationship Between Strikeouts and Home Runs")
plot + stat_smooth(method= "lm") ##stat_smooth fits the model and then we plot the linear regression model
```

---
title: "Team Payroll and the World Series"
author: "Michael Friendly"
date: "`r Sys.Date()`"
output: 
  rmarkdown::html_vignette:
    toc: true
vignette: >
  %\VignetteIndexEntry{Team Payroll and the World Series}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r nomessages, echo = FALSE}
# set some default options for chunks
knitr::opts_chunk$set(
  warning = FALSE,   # avoid warnings and messages in the output
  message = FALSE,
  collapse = TRUE,   # collapse all output into a single block
  tidy = FALSE,      # don't tidy our code-- assume we do it ourselves
  fig.height = 5,
  fig.width = 5
)
options(digits=4)    # number of digits to display in output; can override with chunk option R.options=list(digits=)
par(mar=c(3,3,1,1)+.1)

set.seed(1234)       # reproducibility
```

```{r load-packages, echo=FALSE}
library(Lahman)   # Load additional packages here 
library(ggplot2)
library(dplyr)
```

This vignette examines whether there is a relationship between total team salaries (payroll) and World Series success.
It was inspired by Nolan & Lang (2015), "Baseball: Exploring Data in a Relational Database", 
Chapter 10 in [*Data Science in R*](https://www.routledge.com/Data-Science-in-R-A-Case-Studies-Approach-to-Computational-Reasoning-and-Problem-Solving/Nolan-Lang/p/book/9781482234817). They use `SQL` on the raw Lahman files `.csv`, rather
than the Lahman package.

Here, We largely use `dplyr` for data munging and `ggplot2` for plotting.
In the process, we discover a few errors in the data sets.

## The data files

Start with loading the files we will use here.  We do some pre-processing to make them more convenient for the
analyses done later.

### The `Salaries` data

The `Salaries` data.frame contains data on all players' salaries from 1985-2016 in the latest release, v. `r packageVersion("Lahman")`,
of the `Lahman` package.  (Additions to the `Salaries` table in San Lahman's database were discontinued after 2016.)
We use the `sample_n` function to display a random sample of observations.
```{r}
data("Salaries", package="Lahman")
str(Salaries)
sample_n(Salaries, 10)
```

### The `Teams` data

The `Teams` data.frame contains a lot of information about all teams that have ever played, with a separate observation for each year.
Here, we will mainly use this to get the team name (`team`) from `teamID` and also to get the information about World Series winners.

```{r Teams-names}
data("Teams", package="Lahman")
dim(Teams)
names(Teams)
```

We are only going to use the observations from 1985 on, and a few variables, so we filter and select them now.
Keep only the levels of `teamID` in the data.

```{r Teams-filter}
Teams <- Teams %>%
  select(yearID, lgID, teamID, name, divID, Rank, WSWin, attendance) %>%
  filter(yearID >= 1985) %>%
  mutate(teamID = droplevels(teamID))

sample_n(Teams, 10)
```

### The `SeriesPost` data

Post season records go back to 1884. There are `r nrow(Lahman::SeriesPost)` observations
covering all aspects of post-season play.

```{r SeriesPost-names}
data("SeriesPost", package="Lahman")
names(SeriesPost)
```

For each year, there are number of observations for the various levels of post-season play
(Division titles, League titles, etc. A number of these designations have changed over the years, and
I don't know what they all mean.)

```{r}
table(SeriesPost$round)
```

We are interested only in the World Series (`WS`), which was first played in 1903.
We filter for the years for which we have salary data, and drop a couple of variables.
The league IDs of the winner and loser are factors, so we use `droplevels` to
include only the levels in recent history.

```{r filter-WS}
WS <- SeriesPost %>%
  filter(yearID >= 1985 & round == "WS") %>%
  select(-ties, -round) %>%
  mutate(lgIDloser = droplevels(lgIDloser),
         lgIDwinner = droplevels(lgIDwinner))
dim(WS)
sample_n(WS, 6)
```


## A first look at `Salaries`

How many players do we have in each year?
```{r}
table(Salaries$yearID)
```

What is the range of salaries, across all years?
```{r}
range(Salaries$salary)
```

And, year by year?
```{r}
Salaries %>% 
  group_by(yearID) %>% 
  summarise(min=min(salary),
            max=max(salary))
```
Hmm, there is a `salary==0` in 1993, maybe there are others.

```{r}
which(Salaries$salary==0)
```
Who are they? (We could also look up their `playerID`s in `Lahman::People`.)
```{r which-zero}
Salaries[which(Salaries$salary==0),]
```
These must be errors. Get rid of them. **Reminder**: Check further; maybe file an 
[issue](https://github.com/cdalzell/Lahman/issues)
in the Lahman package!

```{r filter-salaries}
Salaries <- Salaries %>%
    filter(salary !=0)
```


### Get team payrolls

We want to sum the `salary` for each team for each year. We might as well make it in millions.
All those zeros hurt my eyes.


```{r summarise-salaries}
payroll <- Salaries %>%
                group_by(teamID, yearID) %>%
                summarise(payroll = sum(salary)/1000000)
head(payroll)
```

### Merge team names into `payroll`

It will be more convenient to have the team names included in the `payroll` data.frame. 
The `Teams` data frame also contains the `Y/N` indicator `WSWin` for World Series winners,
so we might as well include this too.

```{r merge-teams}
payroll <- merge(payroll, Teams[,c("yearID", "teamID","name", "WSWin")], 
                 by=c("yearID", "teamID")) 
sample_n(payroll, 10)
```

Note that we could also do this using `left_join` in the `dplyr` package.  There is probably a more `tidy` way to 
subset the variables from the `Teams` data set than using `Teams[, c()]`, but, hey-- this works.

```{r eval=FALSE}
left_join(payroll, Teams[,c("yearID", "teamID","name", "WSWin")], 
          by=c("yearID", "teamID")) %>% 
  sample_n(10)
```

`WSWin` is a character variable.  Convert it to a factor.

```{r make-WSWin-factor}
payroll <- payroll %>%
  mutate(WSWin = factor(WSWin))
```

Check the values:

```{r}
table(payroll$WSWin, useNA="ifany")
```
There is something wrong here! There shouldn't be any `NA`s.  We leave this for further study, and another
**Reminder** to file an issue if we figure out what the problem is.

## Boxplots of payroll

Let's look at the distributions of payroll by year.  The observations are teams.
```{r payroll-boxplot, fig.width=7}
boxplot(payroll ~ yearID, data=payroll, ylab="Payroll ($ millions)")
```
What are the outliers?  Are there any teams that crop up repeatedly?
`car::Boxplot` makes this easy, and also returns the labels of the outliers.
We don't load the `car` package, because `car` also contains a `Salary` dataset.

```{r, payroll-Boxplot, fig.width=7}
out <- car::Boxplot(payroll ~ yearID, data=payroll,
             id=list(n=1, 
                     labels=as.character(payroll$teamID)), 
             ylab="Payroll ($ millions)")
```

Most of the outliers are the New York Yankees (`NYA`):
```{r}
table(out)
```


Payroll has obviously increased dramatically over time.  So has the variability across teams. For any modelling,
we would probably want to use `\log(payroll)`.  We might also want to look separately at the
American and National leagues.

### Correcting for inflation
For proper comparisons, we should correct for inflation. Lets do this by scaling salary
back to 1985 dollars,
The data below gives inflation rates for all subsequent years. It comes from Nolan & Lang, extended to 2015
using (https://www.in2013dollars.com/).

```{r}
inflation = c(1,    1.02, 1.06, 1.10, 1.15, 1.21, 
              1.27, 1.30, 1.34, 1.38, 1.42, 1.46, 1.49, 1.51, 1.55, 1.60,
              1.65, 1.67, 1.71, 1.76, 1.82, 1.87, 1.93, 2.00, 1.99, 2.03,
              2.09, 2.13, 2.16, 2.20, 2.20 )

inflation.df <- data.frame(year=1985:2015, inflation)

# plot inflation rate
ggplot(inflation.df, aes(y=inflation, x=year)) +
  geom_point() +
  geom_line() +
  geom_smooth(method="lm")
  
```

This is close enough to linear, that we could use the linear regression predicted
value as a simple computation of the inflation rate.
(A better way, of course, would be to use the actual inflation rate; this would entail
merging `payroll` with `inflation.df` by year, and doing the computation.)

```{r}
infl.lm <- lm(inflation ~ year, data=inflation.df)
(coefs <- coef(infl.lm))
```

Scale `payroll` by dividing by linear prediction of inflation rate, producing `payrollStd`.
```{r}
payroll <- payroll %>%
  mutate(payrollStd = payroll / (coefs[1] + coefs[2] * yearID))
```

Boxplot again, of inflation-adjusted payroll. The increase after 2000 doesn't seem so
large.

```{r, payroll-Boxplot2, fig.width=7}
car::Boxplot(payrollStd ~ yearID, data=payroll,
             id = list(labels=as.character(payroll$teamID)), 
             ylab="Payroll (1985-adjusted $ millions)")
```

## Salaries of World Series winning teams

To what extent are the World Series winners those among the highest in payroll?
A simple way to look at this is to plot the team payrolls across years, and mark
the World Series winner for each year.

This plot shows inflation-adjusted payroll on a log scale to avoid the dominating
influence of the most recent years.  We jitter the points to avoid overplotting,
and use a transparent gray color for the non-winners, red for the winner in each
year.

```{r, payroll-winners-plot, fig.width=7}
Cols <- ifelse(payroll$WSWin=='Y', "red", gray(.7, alpha=0.5))
with(payroll, {
  plot(payrollStd ~ jitter(yearID, 0.5), 
       ylab = "Payroll (inflation-adjusted $ millions)",
       ylim = c(5,125), log = "y",
       xlab = "Year",
       pch = 19, cex = 0.8, col = Cols)
})
with(payroll[payroll$WSWin == 'Y',],
     text(y = payrollStd, x = yearID, labels = teamID, pos = 3, cex = 0.8) )
```

By and large, the World Series winners tend to be in the upper portion of the payrolls for each year.


## Further analyses: Your turn

Here are some questions to provoke further analyses of these data sets.  If you find something interesting, post it in a [Github Gist](https://gist.github.com/) or forward it to Team Lahman as in a [Lahman issue](https://github.com/cdalzell/Lahman/issues).

* Our boxplots used total payroll in millions.  Would the plots be clearer if we plotted payroll on a log scale?

* Follow-up the suggestion to fit a linear model predicting `log(payroll)` from
some of the available predictors.

* Examine the trend of team salaries over time for World Series losers. Does it look the same or different than that for the winning teams?

* What kind of analysis would you do to address this statement: "For teams that make it to the World series, the one with the larger payroll is more likely to win."

* Is there any relationship between the number of team wins in a season and winning the World series?

---
title: "Vignette Introduction"
author: "Martin Monkman"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Vignette Introduction}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Introduction


These vignettes serve a dual purpose:

* to introduce users of the `Lahman` package to the breadth and depth of the data, and a range of analysis and statistical methods that can be undertaken using the data in the package, 

* to introduce users to the statistical software **R**, but particularly to the modern use
in statistics and data science encapsulated in the `tidyverse` of R packages designed to
facilitate data input and manipulation and graphics.


## Contents

Vignettes completed to-date:


1. [Relationship Between Strikeouts and Home Runs](strikeoutsandhr.Rmd) -- This vignette looks at the relationship between rate of strikeouts and home runs from the year 1950+. This question was inspired by Marchi and Albert (2014), _Analyzing Baseball Data in R_. 

    + R packages demonstrated: [`car` (Companion to Applied Regression)](https://CRAN.R-project.org/package=car)


2. [Run Scoring Trends](run-scoring-trends.Rmd) -- Major League Baseball average per-game run scoring for each season since 1901.


3. [Team Payroll and the World Series](payroll.Rmd) -- This vignette examines whether there is a relationship between total team salaries (payroll) and World Series success.


4. [Primer for Full House Modeling](FHM-primer.Rmd) -- This vignette introduces the key ideas behind Full House Modeling, a framework connecting observed achievement to latent talent distributions. It walks through the statistical foundations and demonstrates an application comparing batting averages across eras.



***

## Further reading

A number of books and on-line resources use the `Lahman` package as material for the examples. These include:

### Books

Michael Friendly and David Meyer (2016) _Discrete Data Analysis with R: Visualization and Modeling Techniques for Categorical and Count Data_ (CRC Press). [DDAR Web Site](http://ddar.datavis.ca/)


Max Marchi and Jim Albert (2014) _Analyzing Baseball Data with R_ (CRC Press)

* the book makes frequent reference to the raw Lahman database files in CSV form; the `Lahman` package was relatively recent when the book was published, and authors make a brief mention of the package.
There is a [Baseball with R](https://baseballwithr.wordpress.com/) blog containing extensions
and other analyses.

David Robinson (2017) [_Introduction to Empirical Bayes_](https://drob.gumroad.com/l/empirical-bayes) (published at [gumroad.com])

* the book makes extensive use of the package to explain "the empirical Bayesian approach to estimation, credible intervals, A/B testing, mixture models, and other methods, all through the example of baseball batting averages." 

* the [blog introduction to the book](http://varianceexplained.org/r/empirical-bayes-book/)


Hadley Wickham and Garrett Grolemund (2017) [_R for Data Science: Import, Tidy, Transform, Visualize, and Model Data_](https://r4ds.had.co.nz/) (O'Reilly)

* [Section 5.6.3, "Counts"](https://r4ds.had.co.nz/transform.html#counts)


### Articles, blog entries, and course materials

Shen Yan, Adrian Burgos Jr., Christopher Kinson, and Daniel J. Eck (2024-2025) [Estimation of the MLB talent pool](https://eckeraadjustment.web.illinois.edu/MLBeligiblepop.html)

Steven Buechler (2014-2015) [Analysis of career performance in top home run hitters](https://web.archive.org/web/20230926102540/https://www3.nd.edu/~steve/computing_with_data/16_Baseball_example/baseball_example.html)

* This is lecture 16 from [Computing with Data Seminar](https://web.archive.org/web/20240212000848/https://www3.nd.edu/~steve/computing_with_data/)


Kris Eberwein (2015-09-30) ["Hacking The New Lahman Package 4.0-1 with R-Studio"](https://www.r-bloggers.com/2015/09/hacking-the-new-lahman-package-4-0-1-with-r-studio/) (via [r-bloggers.com])


Michael Lopez (2016) [Lab materials for Skidmore College MA 276, “Sports and Statistics”](https://statsbylopez.com/276labs/)

* [course reference page](https://statsbylopez.com/stats-sports-class/) 


Bill Petti (2015-09-21) [A Short(-ish) Introduction to Using R Packages for Baseball Research](https://tht.fangraphs.com/a-short-ish-introduction-to-using-r-for-baseball-research/)



**_Exploring Baseball Data with R_ blog**

Jim Albert (2018-12-24) [The Vanishing 300 Batting Average](https://baseballwithr.wordpress.com/2018/12/24/the-vanishing-300-batting-average/)

Jim Albert (2015-01-05) [A Graph of a Batting Average](https://baseballwithr.wordpress.com/2015/01/05/a-graph-of-a-batting-average/) 

Brian Mills (2014-09-30) [Using ggmap and Lahman to Find the Hometown College Rosters](https://baseballwithr.wordpress.com/2014/09/30/using-ggmap-and-lahman-to-find-the-hometown-college-rosters/)


-30-

---
title: "Run Scoring Trends"
author: "Martin Monkman"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Run Scoring Trends}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Run scoring trends: Sub-titles and captions with ggplot2


This vignette demonstrates how to create a plot (using `ggplot2`) showing Major League Baseball run scoring trends since the 1901 season.

First, we load the necessary packages: `Lahman` (containing the baseball data), `ggplot2` to create the plots, and the data carpentry package `dplyr` (note that `ggplot2` and `dplyr` are included in the `tidyverse` package):


```{r Setup, message=FALSE}

# package load 
library(Lahman)
library(ggplot2)
library(dplyr)

```

#### Read and summarize the data

For this example, we'll use the data table `Teams` in the Lahman database.

Once it's loaded, the data are filtered and summarized using dplyr.

 - filters from 1901 (the establishment of the American League) to the most recent year,

 - filters out (using `!=`) the Federal League

 - after grouping by the year, summarizes the total number of runs scored, runs allowed, and games played

 - finally, calculates the league runs (`leagueRPG`) and runs allowed (`leagueRAPG`) per game 


```{r, message=FALSE}


data(Teams)


MLB_RPG <- Teams %>%
  filter(yearID > 1900, lgID != "FL") %>%
  group_by(yearID) %>%
  summarise(R=sum(R), RA=sum(RA), G=sum(G)) %>%
  mutate(leagueRPG=R/G, leagueRAPG=RA/G)

```

#### A basic plot

You may have heard that run scoring in Major League Baseball has been down in recent years--or is it going back up? This is a perfect opportunity to visualize the date; what can we see in a plot?

For the first version of the plot, we'll make a basic X-Y plot, where the X axis has the years and the Y axis has the average number of runs scored.  With `ggplot2`, it's easy to add a trend line (using the `geom_smooth` option).

The `scale_x_continuous` options set the limits and breaks of the axes.


```{r, message=FALSE}

MLBRPGplot <- ggplot(MLB_RPG, aes(x=yearID, y=leagueRPG)) +
  geom_point() +
  geom_smooth(span = 0.25) +
  scale_x_continuous(breaks = seq(1900, 2015, by = 20)) +
  scale_y_continuous(limits = c(3, 6), breaks = seq(3, 6, by = 1))

MLBRPGplot

```


The way we would set the title, along with X and Y axis labels, would be something like this.


```{r message=FALSE}
  
MLBRPGplot +
  ggtitle("MLB run scoring, 1901-2016") +
  theme(plot.title = element_text(hjust=0, size=16)) +
  xlab("year") +
  ylab("team runs per game")

```



### Adding a subtitle: the function

So now we have a nice looking dot plot showing the average number of runs scored per game for the years 1901-2016. (The 2016 data is the most recent that has been added to the database.)

But a popular feature of charts--particularly in magazines--is a subtitle that has a summary of what the chart shows and/or what the author wants to emphasize.

In this case, we could legitimately say something like any of the following:

- The peak of run scoring in the 2000 season has been followed by a steady drop

- Teams scored 20% fewer runs in 2016 than in 2000

- Team run scoring has fallen to just over 4 runs per game from the 2000 peak of 5 runs

- Run scoring has been falling for 15 years, reversing a 30 year upward trend

I like this last one, drawing attention not only to the recent decline but also the longer trend that started with the low-scoring environment of 1968.

How can we add a subtitle to our chart that does that, as well as a caption that acknowledges the source of the data?  The new `labs` function, available starting with `ggplot2` version 2.2.0, lets us do that.

Note that `labs` contains the title, subtitle, caption, as well as the X and Y axis labels.

```{r, message=FALSE}

MLBRPGplot +
  labs(title = "MLB run scoring, 1901-2016",
       subtitle = "Run scoring in 2016 was the highest in seven years",
       caption = "Source: the Lahman baseball database", 
       x = "year", y = "team runs per game") 


```


Easy.


For more information about the `labs` function in `ggplot2`, the ["Modify axis, legend, and plot labels"](https://ggplot2.tidyverse.org/reference/labs.html) reference page within the [`ggplot2`](https://ggplot2.tidyverse.org/) site, part of the [Tidyverse](https://tidyverse.org/).


***


This vignette is an update of the blog posts:

* [Major League Baseball run scoring trends with R's Lahman package](https://bayesball.blogspot.com/2013/06/major-league-baseball-run-scoring.html)

* [Run scoring trends: using Shiny to create dynamic charts and tables in R](https://bayesball.blogspot.com/2015/01/run-scoring-trends-using-shiny-to.html)

* [github.com/MonkmanMH/MLBrunscoring_shiny](https://github.com/MonkmanMH/MLBrunscoring_shiny)
